]> git.immae.eu Git - perso/Immae/Config/Nix.git/blobdiff - nixops/scripts/setup
Use Makefile for some env/deploy scripts
[perso/Immae/Config/Nix.git] / nixops / scripts / setup
index 929b27a3b6db719114fb594b03e49a74b6cb9aaf..3b364ac74fa48196d897fef5da72fcb970f59fe7 100755 (executable)
@@ -1,9 +1,9 @@
 #!/bin/bash
 
-set -euxo pipefail
+set -euo pipefail
 
 RemoteRepo="gitolite@git.immae.eu:perso/Immae/Prive/Password_store/Sites"
-DeploymentUuid="cef694f3-081d-11e9-b31f-0242ec186adf"
+MAKEFILE_DIR="$( cd "$( dirname $( dirname "${BASH_SOURCE[0]}" ))" >/dev/null 2>&1 && pwd )"
 
 if ! which nix 2>/dev/null >/dev/null; then
   cat <<-EOF
@@ -52,82 +52,59 @@ if ! pass $NIXOPS_CONFIG_PASS_SUBTREE_PATH > /dev/null 2>/dev/null; then
   fi
 fi
 
-nix_group=$(stat -c %G /nix/store)
-if [ "$nix_group" = "nixbld" ]; then
-  nix_user="nixbld1"
-else
-  nix_user="$(stat -c %U /nix/store)"
-fi
+# Repull it before adding keys, just in case
+make -C $MAKEFILE_DIR pull_environment
 
-if [ ! -f /etc/ssh/ssh_rsa_key_nixops ]; then
-  cat <<-EOF
-       The key to access private git repositories (websites hosted by the
-       server) needs to be accessible to nix builders. It will be put in
-       /etc/ssh/ssh_rsa_key_nixops (sudo right is needed for that)
-       > pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/SshKey | sudo tee /etc/ssh/ssh_rsa_key_nixops > /dev/null
-       > pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/SshKey.pub | sudo tee /etc/ssh/ssh_rsa_key_nixops.pub > /dev/null
-       > sudo chmod u=r,go-rwx /etc/ssh/ssh_rsa_key_nixops
-       > sudo chown $nix_user:$nix_group /etc/ssh/ssh_rsa_key_nixops /etc/ssh/ssh_rsa_key_nixops.pub
-       Continue? [y/N]
-       EOF
-  read y
-  if [ "$y" = "y" -o "$y" = "Y" ]; then
-    if ! id -u $nix_user 2>/dev/null >/dev/null; then
-      echo "User $nix_user seems inexistant, did you install nix?"
+gpg_keys=$(pass ls $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/GPGKeys | sed -e "1d" | cut -d" " -f2)
+for key in $gpg_keys; do
+  content=$(pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/GPGKeys/$key)
+  fpr=$(echo "$content" | gpg --import-options show-only --import --with-colons | grep -e "^pub" | cut -d':' -f5)
+  gpg --list-key "$fpr" >/dev/null 2>/dev/null && imported=yes || imported=no
+  # /usr/share/doc/gnupg/DETAILS field 2
+  (echo "$content" | gpg --import-options show-only --import --with-colons |
+      grep -E '^pub:' |
+      cut -d':' -f2 |
+      grep -q '[fu]') && signed=yes || signed=no
+  if [ "$signed" = no -o "$imported" = no ] ; then
+    echo "The key for $key needs to be imported and signed (a local signature is enough)"
+    echo "$content" | gpg --import-options show-only --import
+    echo "Continue? [y/N]"
+    read y
+    if [ "$y" = "y" -o "$y" = "Y" ]; then
+      echo "$content" | gpg --import
+      gpg --expert --edit-key "$fpr" lsign quit
+    else
+      echo "Aborting"
       exit 1
     fi
-    mask=$(umask)
-    umask 0777
-    # Don’t forward it directly to tee, it would break ncurse pinentry
-    key=$(pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/SshKey)
-    echo "$key" | sudo tee /etc/ssh/ssh_rsa_key_nixops > /dev/null
-    sudo chmod u=r,go=- /etc/ssh/ssh_rsa_key_nixops
-    pubkey=$(pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/SshKey.pub)
-    echo "$pubkey" | sudo tee /etc/ssh/ssh_rsa_key_nixops.pub > /dev/null
-    sudo chmod a=r /etc/ssh/ssh_rsa_key_nixops.pub
-    sudo chown $nix_user:$nix_group /etc/ssh/ssh_rsa_key_nixops /etc/ssh/ssh_rsa_key_nixops.pub
-    umask $mask
-  else
-    echo "Aborting"
-    exit 1
   fi
-fi
+done
 
-if ! which nixops 2>/dev/null >/dev/null; then
+if nix show-config --json | jq -e '.sandbox.value == "true"' >/dev/null; then
   cat <<-EOF
-       nixops is needed:
-       > nix-env -i nixops
-       If it fails, please check that $HOME/.nix-profile/bin is in your PATH.
-       Continue? [y/N]
+       There used to be some impure derivations (grep __noChroot), you may need
+         sandbox = "relaxed"
+       in /etc/nix/nix.conf
+       you may also want to add
+         keep-outputs = true
+         keep-derivations = true
+       to prevent garbage collector from deleting build dependencies (they take a lot of time to build)
+        and
+         allow-import-from-derivation = false
+       as an attempt to avoid having build-time derivations (doesn’t work for all packages)
+       press key to continue
        EOF
   read y
-  if [ "$y" = "y" -o "$y" = "Y" ]; then
-    nix-env -i nixops
-    if ! which nixops 2>/dev/null >/dev/null; then
-      echo "Installation failed, please check that $HOME/.nix-profile/bin is in your path."
-      exit 1
-    fi
-  else
-    echo "Aborting"
-    exit 1
-  fi
 fi
 
-DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
-export NIXOPS_STATE="$(dirname $DIR)/state/eldiron.nixops"
-export NIXOPS_DEPLOYMENT="$DeploymentUuid"
-
-if ! nixops info 2>/dev/null >/dev/null; then
+if ! make -C $MAKEFILE_DIR deployment_is_set 2>/dev/null >/dev/null; then
   cat <<-EOF
        Importing deployment file into nixops:
        Continue? [y/N]
        EOF
   read y
   if [ "$y" = "y" -o "$y" = "Y" ]; then
-    deployment=$(pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/Deployment)
-    echo "$deployment" | nixops import
-
-    nixops modify "$(dirname $DIR)/eldiron.nix"
+    make -C $MAKEFILE_DIR pull_deployment
   else
     echo "Aborting"
     exit 1
@@ -136,5 +113,5 @@ fi
 
 cat <<-EOF
        All set up.
-       Please make sure you’re using scripts/nixops_wrap when deploying
+       Please make sure you’re using make commands when deploying
        EOF